/*
XCOM: UFO defense (aka   UFO: Enemy Unknown) windows version loader, by f0dder.
That's f0dder@druk.nu , http://f0dder.has it , http://f0dder.cjb.net
All rights desrever ;), 2003/04/30.
*/

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <commdlg.h>
#include "mytypes.h"
#include "shared.h"						// shared between loader and patch-dll

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// typedefs and defines
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#pragma pack(push,1)
struct patchheader_t {
	u16		shortjmp;
	u32		hEvent;
	u32		oLoadLibrary;
	u32		oGetProcAddress;
	u32		oSetEvent;
};
#pragma pack(pop)

typedef void (*fnp_t)(dllinfo_t *info);


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// global data
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
static char szError[] = "Error";
static SECURITY_ATTRIBUTES sa = { sizeof(SECURITY_ATTRIBUTES), NULL, TRUE };
#include "patch_bin.h"					// injected dll-loading code


bool fileExists(char *szFname)
{
	return (GetFileAttributes(szFname) != 0xFFFFFFFF);
}


int doThePatch(void)
{
	char				*szErrorMsg;
	char				*szExecutable = NULL;
	char				*szArguments = NULL;
	HMODULE				hDll = NULL;
	patchheader_t		*phdr;
	dllinfo_t			dllinfo;
	STARTUPINFO			si;
	PROCESS_INFORMATION	pi;
	u8					oldbuf[sizeof(data)];
	char				buf[256];
	char				fnbuf[MAX_PATH + 1];
	CONTEXT				ctx;
	HANDLE				hEvent;
	DWORD				exitCode;

	// code
	// load patch.dll
	{
		fnp_t			fnPrepatch;

		hDll = LoadLibrary("patch.dll");
		if(hDll == NULL) {
			szErrorMsg = "Could not load patch.dll";
			goto error;
		}
		fnPrepatch = (fnp_t) GetProcAddress(hDll, "PrePatch");
		if(fnPrepatch == NULL) {
			szErrorMsg = "invalid patch.dll";
			goto error;
		}

		fnPrepatch(&dllinfo);
		FreeLibrary(hDll);
	}


	//Parse commandline. If commandline doesn't start with \", parse to char
	//after first space. If commandline starts with \", parse until \", and
	//fall through to lastspace-parser.
	{
		char	*s = GetCommandLine();
		char	*p;

		// start by skipping executable part (xcom_ldr, not the user-specified one)
		if(*s == '\"') {
			s++;
			while( (*s != '\"') && (*s != '\0')) s++;
		}
		while( (*s != ' ') && (*s != '\0')) s++;
		while( (*s == ' ')) s++;

		// ok, now we are at about the end of user-speficied executable 
		if(*s == '"') {
			p = ++s;
			while((*p != '"') && (*p != '\0')) p++;
		} else {
			p = s;
			while((*p != ' ') && (*p != '\0')) p++;
		}
		if(*s != '\0') {
			szExecutable = s;
		}
		// skip whitespace before user args
		*p++ = '\0';
		while(*p == ' ') p++;
		szArguments = p;
	}

	if(szExecutable == NULL) {
		// executable filename not specified on commandline, scan
		char	*szf, *szb;
		szf = szb = dllinfo.szValidNames;
		while(*szf != '\0') {
			// scan for semicolon
			while(*szb != '\0') {
				if(*szb == ';') {
					*szb++ = '\0';
					break;
				}
				szb++;
			}
			if(fileExists(szf)) {
				szExecutable = dllinfo.szValidNames;
				break;
			}
			szf = szb;
		}
	}

	// v0.9: pop op GetOpenFileName dialog if no executable was found
	if(!fileExists(szExecutable)){
		OPENFILENAME	ofn;
		// ok, executable not found, ask user
		fnbuf[0] = 0;
		memset(&ofn, 0, sizeof(ofn));
		ofn.lStructSize = sizeof(ofn);
		ofn.lpstrFilter = "Program Files\0*.exe\0";
		ofn.lpstrFile = fnbuf;
		ofn.nMaxFile = lengthof(fnbuf);
		ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
		// I don't add OFN_NOCHANGEDIR, so it shouldn't be necessary to chdir
		// to the game folder.

		if(!GetOpenFileName(&ofn)) {
			MessageBox(NULL, "Ok, giving up executable search", "whatever", MB_OK);
			return 200;
		}
		szExecutable = fnbuf;
	}

	//TODO: check if executable is PE?
	//
	// Create an EVENT object the patch can use to signal the loader.
	hEvent = CreateEvent(&sa, TRUE, FALSE, NULL);
	if(hEvent == NULL) {
		szErrorMsg = "Couldn't CreateEvent";
		goto error;
	}
	// store event handle "and stuff" in the patch code
	phdr = (patchheader_t *) data;
	phdr->hEvent = (u32) hEvent;
	phdr->oLoadLibrary = (u32) GetProcAddress(GetModuleHandle("KERNEL32.DLL"), "LoadLibraryA");
	phdr->oGetProcAddress  = (u32) GetProcAddress(GetModuleHandle("KERNEL32.DLL"), "GetProcAddress");
	phdr->oSetEvent  = (u32) GetProcAddress(GetModuleHandle("KERNEL32.DLL"), "SetEvent");

	// create process
	wsprintf(buf, "%s %s", szExecutable, szArguments);
	GetStartupInfo(&si);
	if(!CreateProcess(NULL, buf, NULL, NULL, TRUE, 
		CREATE_DEFAULT_ERROR_MODE | CREATE_SUSPENDED, NULL, NULL,
		&si, &pi))
	{
		szErrorMsg = "Error while executing program";
		goto error;
	}

	// process is now created and in suspended mode. Inject the DLL-loading code.
	// save original entrypoint bytes
	if(!ReadProcessMemory(pi.hProcess, (void *) dllinfo.uEntryPoint, oldbuf, sizeof(oldbuf), NULL)) {
		szErrorMsg = "Couldn't read process memory";
		goto error;
	}

	// write patch
	if(!WriteProcessMemory(pi.hProcess, (void *) dllinfo.uEntryPoint, data, sizeof(data), NULL)) {
		szErrorMsg = "couldn't write process memory (1)";
		goto error;
	}

	// the patch codes writes to the executable, so we must unprotect it
	Sleep(0);					// give up remaining timeslice to make the next code less likely to fail.
	ResumeThread(pi.hThread);
	if (WaitForSingleObject(hEvent, 2500) != WAIT_OBJECT_0) {
		szErrorMsg = "Patch code timed out";
		goto error;
	}

	// restore program and run
	SuspendThread(pi.hThread);

	if(!WriteProcessMemory(pi.hProcess, (void *) dllinfo.uEntryPoint, oldbuf, sizeof(oldbuf), NULL)) {
		szErrorMsg = "couldn't write process memory (2)";
		goto error;
	}

	ctx.ContextFlags = CONTEXT_CONTROL;
	GetThreadContext(pi.hThread, &ctx);
	ctx.Eip = dllinfo.uEntryPoint;
	SetThreadContext(pi.hThread, &ctx);
	ResumeThread(pi.hThread);
	WaitForSingleObject(pi.hProcess, INFINITE);
	if(!GetExitCodeProcess(pi.hProcess, &exitCode))
		return 200;
	return exitCode;

error:
	MessageBox(NULL, szErrorMsg, szError, MB_OK | MB_ICONEXCLAMATION);
	return 200;
}

void entry32(void)
{
	ExitProcess(doThePatch());
}
